

module ProteinTranslate

	#Clase para traduciar una cadena en ARN
	#a los codones y proteinas correspondientes
	class ProteinTranslate
		
		attr_reader :equivalence, :stop

		def initialize

			#Hash que contiene las equivalencias entre
			#codones y las respectivas proteínas
			@equivalence = {
				"AUG" => "Methionine",
				"UUU" => "Phenylalanine",
				"UUC" => "Phenylalanine",
				"UUA" => "Leucine",
				"UUG" => "Leucine",
				"UCU" => "Serine",
				"UCC" => "Serine",
				"UCA" => "Serine",
				"UCG" => "Serine",
				"UAU" => "Tyrosine",
				"UAC" => "Tyrosine",
				"UGU" => "Cysteine",
				"UGC" => "Cysteine",
				"UGG"=> "Tryptophan"
			}

			#Array que contiene los valores que si son detectados
			#en la cadena indican que se pueden terminar la traduccion
			@stop = ["UAA", "UAG", "UGA"]
		end

		#Metodo que recibe una cadena y devuelve
		#un array de codons que la conforman
		def divideStringInCondons(cadena)
			array = Array.new
			i = 0
			while i <= cadena.length-3
				if (@stop.include?("#{cadena[i,3]}"))
					break
				end
				array << cadena[i,3]
				i += 3
			end
			array
		end

		#Metodo que recibe una cadena y devuelve un array con las
		#proteinas que la conforman
		#Previamente se convierten en codones
		def translateString(cadena)
			array = divideStringInCondons(cadena)
			proteina = Array.new
			i = 0
				array.each do |value|
					if(@equivalence.has_key?("#{value}"))
						proteina[i] = @equivalence["#{value}"]
						i += 1
					end
				end
			proteina
		end

	end

end